//+------------------------------------------------------------------+
//|                                       usrednenie+stoxastik.mq4   |
//|                                              Avtor Kostenko Vlad |
//|                                                   Yeisk 2008     |
//|                                            Sederevichys Victor   |
//|                                                  Ghodino 2009    |
//+------------------------------------------------------------------+
extern int _MM = 1;  // Mathemat 0-fix lot=lot;1-  ;
extern double target_1=20;
extern double K1 = 279;// M5
extern double P1 = 8;// M5
extern double S1 = 56;// M5
extern double K2 = 95;// M15
extern double P2 = 6;// M15
extern double S2 = 16;// M15
extern int magic=777;
extern int dist=4;
extern bool control_equity=true;// 

double tp_buy=0.0001;
double tp_sell=0.0001; 
int cbars=0;
//-----------------------------------------------------
void init() {	return; }
//-----------------------------------------------------
void start() 
{
	string smb=Symbol();
	CheckTP(smb); CheckBuy(smb); CheckSell(smb); 
	CheckLoss(smb); cbars=Bars; return;
} 
//-----------------------------------------------------
void CheckTP(string smb)
{
	int i, total, n;
	double Lots, op, tp;
	
	total=OrdersTotal();
	
	Lots=0; n=0; op=0; tp=0;
	for (i=0; i<total; i++)
	{
		OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
		if(OrderMagicNumber()==magic && OrderSymbol()==smb) { n++; op=op+OrderOpenPrice(); Lots=Lots+OrderLots(); }  
	}
	if(n>0) tp=ND(op/n+ND(0.1/Lots,2)*target_1*Point);
	if(tp!=tp_buy && tp!=0)
	{
		tp_buy=tp;
		for (i=0; i<total; i++)
		{
			OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
			if(OrderType()==OP_BUY && OrderMagicNumber()==magic && OrderSymbol()==smb)
				OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(),tp,0,Blue);
		}
	}  
	
	Lots=0; n=0; op=0; tp=0;
	for (i=0; i<total; i++)
	{
		OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
		if(OrderMagicNumber()==magic && OrderSymbol()==smb) { n++; op=op+OrderOpenPrice(); Lots=Lots+OrderLots(); }
	}
	if(n>0) tp=ND(op/n-ND(0.1/Lots,2)*target_1*Point);
	if(tp!=tp_sell && tp!=0)
	{
		tp_sell=tp;
		for (i=0; i<total; i++)
		{
			OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
			if(OrderType()==OP_SELL && OrderMagicNumber()==magic && OrderSymbol()==smb)
				OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), tp, 0,Blue);
		}
	}
	return;
}
//-----------------------------------------------------
void CheckBuy(string smb)
{
	if (cbars==Bars) return;
	double m1, s1, m2, s2;
	if(iLowest(smb,0,MODE_LOW, dist, 0)==1)
	{
		m1=iStochastic(smb,5,K1,P1,S1,MODE_SMA,0,MODE_MAIN,0); s1=iStochastic(smb,5,K1,P1,S1,MODE_SMA,0,MODE_SIGNAL,0);
		m2=iStochastic(smb,15,K2,P2,S2,MODE_SMA,0,MODE_MAIN,0); s2=iStochastic(smb,15,K2,P2,S2,MODE_SMA,0,MODE_SIGNAL,0);
		if(m1<20 && s1<20 && m1>s1 &&	m2<20 && s2<20 && m2>s2)
		{ 
			string AN="ArrBuy "+TimeToStr(TimeCurrent()); ObjectCreate(AN,OBJ_ARROW,0,Time[1],Low[1]-6*Point,0,0,0,0);
			ObjectSet(AN, OBJPROP_ARROWCODE, 233); ObjectSet(AN, OBJPROP_COLOR , Blue);
			OrderSend(smb, OP_BUY, LotSize(smb), ND(Ask), 3, 0, 0,"buy", magic,0,Blue); 
		}  
	}
	return;      
}    
//-----------------------------------------------------
void CheckSell(string smb)
{
	if (cbars==Bars) return;
	double m1, s1, m2, s2;
	if(iHighest(smb, 0, MODE_HIGH, dist, 0)==1)
	{
		m1=iStochastic(smb, 5,K1,P1,S1,MODE_SMA,0,MODE_MAIN,0); s1=iStochastic(smb, 5,K1,P1,S1,MODE_SMA,0,MODE_SIGNAL,0);
		m2=iStochastic(smb, 15,K2,P2,S2,MODE_SMA,0,MODE_MAIN,0); s2=iStochastic(smb, 15,K2,P2,S2,MODE_SMA,0,MODE_SIGNAL,0);
		if(m1>80 && s1>80 && m1<s1 && m2>80 && s2>80 && m2<s2)
		{
			string AN="ArrSell "+TimeToStr(TimeCurrent()); ObjectCreate(AN,OBJ_ARROW,0,Time[1],High[1]+6*Point,0,0,0,0);
			ObjectSet(AN, OBJPROP_ARROWCODE, 234); ObjectSet(AN, OBJPROP_COLOR , Red);
			OrderSend(smb, OP_SELL, LotSize(smb), ND(Bid),3, 0, 0, "sell", magic, 0, Red);
		}
	}  
	return;      
}
//-----------------------------------------------------
void CheckLoss(string smb)//    20%  ,       ( ....) 
{ 
	if (!control_equity) return;
	double maxloss=0;
	int ticket=0;

	int i, total=OrdersTotal();
	if(AccountEquity()<AccountBalance()*0.8)
	{
		ticket=0; maxloss=0;
		for (i=0;i<total; i++)
		{
			OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
			if(OrderMagicNumber()==magic && OrderSymbol()==smb)
				if(OrderProfit()<0 && OrderProfit()<maxloss) { maxloss=OrderProfit(); ticket=OrderTicket(); }
		}
		if (ticket!=0) OrderClose(ticket, OrderLots(), Bid, 3,Blue);
	}
	if(AccountEquity()<AccountBalance()*0.8)
	{
		ticket=0; maxloss=0;
		for (i=0; i<total; i++)
		{
			OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
			if(OrderMagicNumber()==magic && OrderSymbol()==smb)
				if(OrderProfit()<0 && OrderProfit()<maxloss) { maxloss=OrderProfit(); ticket=OrderTicket(); }     
		}
		if (ticket!=0) OrderClose(ticket, OrderLots(), Ask, 3, Blue);
	}
	return;
}
//-----------------------------------------------------
double LotSize(string smb) 
{
	double size=0.01, lot=0;
	if (_MM==1) size=0.1*MathSqrt(AccountBalance()/20000); //0.02

	lot=ND(size, 2); 
	if (size<0.01) //      0.1 ?
	{
		if (AccountFreeMarginCheck(smb, OP_BUY, 0.01)<10. || AccountFreeMarginCheck(smb, OP_SELL, 0.01)<10. || GetLastError()==134)
			lot = 0.0; // ,  
		else lot= 0.01; // ;  0.01
	}
	return(lot); 
}
//-----------------------------------
double ND(double d, int n=-1) { if (n<0) return(NormalizeDouble(d, Digits)); return(NormalizeDouble(d, n)); }